from typing import List

from fastapi import HTTPException
from starlette import status

from ucsschool.kelvin.client import Session, User, UserResource


async def user_getter_by_broker_id(broker_id: str, session: Session) -> List[User]:
    # using udm_kwargs_rw instead of udm_kwargs_ro, because it is faster (skipping LDAP ACLs)
    if "*" in broker_id:
        raise HTTPException(
            status_code=status.HTTP_422_UNPROCESSABLE_ENTITY,
            detail="Exact match required, '*' not allowed.",
        )
    return [obj async for obj in UserResource(session=session).search(brokerID=broker_id)]
